<?php

/**
 * inf_pin_recha actions.
 *
 * @package    cartera
 * @subpackage inf_pin_recha
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_pin_rechaActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.id_tipo_pago, tab0.fecha_log, tab0.num_pin';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            $whereTipoPago = " ";
            if (isset($request['tipo_pago']) && $request['tipo_pago'] != '0') {
                $whereTipoPago = " and tab0.id_tipo_pago in (" . $request['tipo_pago'] . ")";
            }



            /*
             * Variables opcionales
             */
            /**
             * si se tiene el CcCheckBox de nombre "exacto" puede habilitar para valor exacto o un rango de valores
             * cuando es true habilita el parametro:  "valor_exacto" y "valor_total"
             * cuando es false habilita el rango de los parametros: "valor" y "valor_total"
             */
            $whereValorPago = " ";
            if (isset($request['exacto'])) {

                if ($request['exacto'] == 'true') {
                    if (isset($request['valor_exacto'])) {
                        if ($request['valor_exacto'] != "") {
                            $whereValorPago = " AND tab0.valor_pago = " . $request['valor_exacto'];
                        }
                    }
                } else {
                    if (isset($request['valor_ini'])) {
                        if ($request['valor_ini'] != "") {
                            $whereValorPago = " AND tab0.valor_pago >= " . $request['valor_ini'];
                        }
                    }
                    if (isset($request['valor_fin'])) {
                        if ($request['valor_fin'] != "") {
                            $whereValorPago .= " AND tab0.valor_pago <= " . $request['valor_fin'];
                        }
                    }
                }
            }


            //id_ts_td
            if (isset($request['id_ts_td'])) {
                $whereTipoDocumento = " AND tab0.id_ts_td = " . $request['id_ts_td'];
            } else {
                $whereTipoDocumento = ' ';
            }
            //id_mae_ter
            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }
            //pin
            if (isset($request['pin'])) {
                $wherePin = " AND tab0.num_pin = '" . $request['pin'] . "'";
            } else {
                $wherePin = ' ';
            }
            //codigo_soporte
            if (isset($request['codigo_soporte'])) {
                $whereCodigoSoporte = " AND tab0.codigo_soporte = " . $request['codigo_soporte'];
            } else {
                $whereCodigoSoporte = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

SELECT 
tab0.id_tipo_pago,
tab0.tipo_pago,
tab0.num_pin,
tab0.valor_pago,
tab0.fecha_soporte,
tab0.id_ts_td,
tab0.codigo_td,
tab0.descripcion_td,
tab0.id_mae_ter,
tab0.num_doc,
tab0.razon_soc,
tab0.codigo_soporte,
tab0.estado,
tab0.estado_text,
tab0.codigo_auxiliar,
tab0.observaciones,
tab0.fecha_log    
   
FROM web_pagos_off_v tab0

where   
trunc(tab0.fecha_log) between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD') 
$whereValorPago $whereTipoPago 
$whereTipoDocumento
$whereTercero        
$wherePin
$whereCodigoSoporte                     
   
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

SELECT 
tab0.id_tipo_pago,
tab0.tipo_pago,
tab0.num_pin,
tab0.valor_pago,
tab0.fecha_soporte,
tab0.id_ts_td,
tab0.codigo_td,
tab0.descripcion_td,
tab0.id_mae_ter,
tab0.num_doc,
tab0.razon_soc,
tab0.codigo_soporte,
tab0.estado,
tab0.estado_text,
tab0.codigo_auxiliar,
tab0.observaciones,
tab0.fecha_log   
   
FROM web_pagos_off_v tab0

where   
trunc(tab0.fecha_log) between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD') 
$whereValorPago $whereTipoPago 
$whereTipoDocumento
$whereTercero        
$wherePin
$whereCodigoSoporte 
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_pag_web_pin] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_pin';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            $whereTipoPago = " ";
            if (isset($request['tipo_pago']) && $request['tipo_pago'] != '0') {
                $whereTipoPago = " and tab0.id_tipo_pago in (" . $request['tipo_pago'] . ")";
            }



            /*
             * Variables opcionales
             */
            /**
             * si se tiene el CcCheckBox de nombre "exacto" puede habilitar para valor exacto o un rango de valores
             * cuando es true habilita el parametro:  "valor_exacto" y "valor_total"
             * cuando es false habilita el rango de los parametros: "valor" y "valor_total"
             */
            $whereValorPago = " ";
            if (isset($request['exacto'])) {

                if ($request['exacto'] == 'true') {
                    if (isset($request['valor_exacto'])) {
                        if ($request['valor_exacto'] != "") {
                            $whereValorPago = " AND tab0.valor_pago = " . $request['valor_exacto'];
                        }
                    }
                } else {
                    if (isset($request['valor_ini'])) {
                        if ($request['valor_ini'] != "") {
                            $whereValorPago = " AND tab0.valor_pago >= " . $request['valor_ini'];
                        }
                    }
                    if (isset($request['valor_fin'])) {
                        if ($request['valor_fin'] != "") {
                            $whereValorPago .= " AND tab0.valor_pago <= " . $request['valor_fin'];
                        }
                    }
                }
            }


            //id_ts_td
            if (isset($request['id_ts_td'])) {
                $whereTipoDocumento = " AND tab0.id_ts_td = " . $request['id_ts_td'];
            } else {
                $whereTipoDocumento = ' ';
            }
            //id_mae_ter
            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }
            //pin
            if (isset($request['pin'])) {
                $wherePin = " AND tab0.num_pin = '" . $request['pin'] . "'";
            } else {
                $wherePin = ' ';
            }
            //codigo_soporte
            if (isset($request['codigo_soporte'])) {
                $whereCodigoSoporte = " AND tab0.codigo_soporte = " . $request['codigo_soporte'];
            } else {
                $whereCodigoSoporte = ' ';
            }

            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'Total: ' || count(*) as tipo_pago,
SUM(valor_pago) as valor_pago

FROM (  

SELECT 
tab0.id_tipo_pago,
tab0.tipo_pago,
tab0.num_pin,
tab0.valor_pago,
tab0.fecha_soporte,
tab0.id_ts_td,
tab0.codigo_td,
tab0.descripcion_td,
tab0.id_mae_ter,
tab0.num_doc,
tab0.razon_soc,
tab0.codigo_soporte,
tab0.estado,
tab0.estado_text,
tab0.codigo_auxiliar,
tab0.observaciones,
tab0.fecha_log       
   
FROM web_pagos_off_v tab0

where   
tab0.fecha_log between to_date('$fecha_ini', 'YYYY-MM-DD') and to_date('$fecha_fin', 'YYYY-MM-DD') 
$whereValorPago $whereTipoPago 
$whereTipoDocumento
$whereTercero        
$wherePin
$whereCodigoSoporte  
    
$sortBy                    
                    
)
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
